package xyz.lychee.lagfixer.libs.adventure.text.serializer.gson;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import java.util.function.Consumer;
import java.util.function.UnaryOperator;
import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.serializer.ComponentSerializer;
import xyz.lychee.lagfixer.libs.adventure.util.Buildable;
import xyz.lychee.lagfixer.libs.adventure.util.PlatformAPI;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.Internal;

public interface GsonComponentSerializer extends ComponentSerializer<Component, Component, String>, Buildable<GsonComponentSerializer, Builder> {
   static @NotNull GsonComponentSerializer gson() {
      return GsonComponentSerializerImpl.Instances.INSTANCE;
   }

   static @NotNull GsonComponentSerializer colorDownsamplingGson() {
      return GsonComponentSerializerImpl.Instances.LEGACY_INSTANCE;
   }

   static Builder builder() {
      return new GsonComponentSerializerImpl.BuilderImpl();
   }

   @NotNull Gson serializer();

   @NotNull UnaryOperator<GsonBuilder> populator();

   @NotNull Component deserializeFromTree(final @NotNull JsonElement input);

   @NotNull JsonElement serializeToTree(final @NotNull Component component);

   @PlatformAPI
   @Internal
   public interface Provider {
      @PlatformAPI
      @Internal
      @NotNull GsonComponentSerializer gson();

      @PlatformAPI
      @Internal
      @NotNull GsonComponentSerializer gsonLegacy();

      @PlatformAPI
      @Internal
      @NotNull Consumer<Builder> builder();
   }

   public interface Builder extends AbstractBuilder<GsonComponentSerializer>, Buildable.Builder<GsonComponentSerializer> {
      @NotNull
      @NotNull Builder downsampleColors();

      @NotNull
      @NotNull Builder legacyHoverEventSerializer(final @Nullable LegacyHoverEventSerializer serializer);

      @NotNull
      @NotNull Builder emitLegacyHoverEvent();

      @NotNull GsonComponentSerializer build();
   }
}
